<template>
    <a-layout>
        <a-layout-header :style="{ position: 'fixed', zIndex: 1, width: '100%', top: 0, left: 0 }">
            <div class="logo" />
            <a-menu v-model:selectedKeys="selectedKeys" theme="dark" mode="horizontal" :style="{ lineHeight: '64px', display: 'block' }">
                <a-menu-item key="/" :style="{ backgroundColor: 'transparent !important' }">
                    <NuxtLink to="/">Home</NuxtLink>
                </a-menu-item>

                <a-menu-item :style="{ float: 'right', backgroundColor: 'transparent !important' }" v-if="user?.id">
                    <a-dropdown :trigger="['click']">
                        <a class="ant-dropdown-link" @click.prevent>
                            <UserOutlined />
                        </a>
                        <template #overlay>
                            <a-menu>
                                <a-menu-item :style="{ color: '#1677ff' }">
                                    <a-typography-link href="/change-pw" target=""> Change Password </a-typography-link>
                                </a-menu-item>

                                <a-menu-item danger>
                                    <a v-on:click="handleLogout">Logout</a>
                                </a-menu-item>
                            </a-menu>
                        </template>
                    </a-dropdown>
                </a-menu-item>
                <a-menu-item key="/register" :style="{ float: 'right', backgroundColor: 'transparent !important' }" v-else><NuxtLink to="/register">Register</NuxtLink></a-menu-item>

                <a-menu-item :style="{ float: 'right', backgroundColor: 'transparent !important', cursor: 'text' }" v-if="user?.id">{{ user?.name }}</a-menu-item>
                <a-menu-item key="/login" :style="{ float: 'right', backgroundColor: 'transparent !important' }" v-else><NuxtLink to="/login">Login</NuxtLink></a-menu-item>
            </a-menu>
        </a-layout-header>
        <a-spin :spinning="isLoaded">
            <slot />
        </a-spin>
    </a-layout>
</template>
<script lang="ts" setup>
import { ref } from "vue";

const authStore = useAuthStore();
const userStore = useUserStore();
const { user, isLoaded } = storeToRefs(userStore);


watch(user, () => {
    console.log("isLoggedIn ref changed, do something!");
});

const handleLogout = async () => {
    isLoaded.value = true;
    try {
        await authStore.logout();
    } catch (error: any) {
        Promise.reject(error);
    } finally {
        isLoaded.value = false;
    }
};

const route = useRoute();
let path = route.path;

const selectedKeys = ref<string[]>([`${path}`]);
</script>
<style scoped>
#components-layout-demo-fixed .logo {
    width: 120px;
    height: 31px;
    background: rgba(255, 255, 255, 0.2);
    margin: 16px 24px 16px 0;
    float: left;
}
.site-layout .site-layout-background {
    background: #fff;
}

[data-theme="dark"] .site-layout .site-layout-background {
    background: #141414;
}
</style>
